org.encog.mathutil.matrices.decomposition

## Class LUDecomposition

- java.lang.Object
- - org.encog.mathutil.matrices.decomposition.LUDecomposition

-     public class LUDecomposition
      extends Object

  LU Decomposition.

  For an m-by-n matrix A with m >= n, the LU decomposition is an m-by-n unit lower triangular matrix L, an n-by-n upper triangular matrix U, and a permutation vector piv of length m so that A(piv,:) = L*U. If m < n, then L is m-by-m and U is m-by-n.

  The LU decompostion with pivoting always exists, even if the matrix is singular, so the constructor will never fail. The primary use of the LU decomposition is in the solution of square systems of simultaneous linear equations. This will fail if isNonsingular() returns false. This file based on a class from the public domain JAMA package. http://math.nist.gov/javanumerics/jama/

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LUDecomposition(Matrix A)` LU Decomposition Structure to access L, U and piv.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `det()` Determinant
    `double[]` | `getDoublePivot()` Return pivot permutation vector as a one-dimensional double array
    `Matrix` | `getL()` Return lower triangular factor
    `int[]` | `getPivot()` Return pivot permutation vector
    `Matrix` | `getU()` Return upper triangular factor
    `double[][]` | `inverse()` Solves a set of equation systems of type A * X = B.
    `boolean` | `isNonsingular()` Is the matrix nonsingular?
    `double[]` | `Solve(double[] value)`
    `Matrix` | `solve(Matrix B)` Solve A*X = B

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LUDecomposition

          public LUDecomposition(Matrix A)

      LU Decomposition Structure to access L, U and piv.
      Parameters:
        `A` - Rectangular matrix

  - ### Method Detail

    - #### isNonsingular

          public boolean isNonsingular()

      Is the matrix nonsingular?
      Returns:
        true if U, and hence A, is nonsingular.

    - #### getL

          public Matrix getL()

      Return lower triangular factor
      Returns:
        L

    - #### getU

          public Matrix getU()

      Return upper triangular factor
      Returns:
        U

    - #### getPivot

          public int[] getPivot()

      Return pivot permutation vector
      Returns:
        piv

    - #### getDoublePivot

          public double[] getDoublePivot()

      Return pivot permutation vector as a one-dimensional double array
      Returns:
        (double) piv

    - #### det

          public double det()

      Determinant
      Returns:
        det(A)
      Throws:
        `IllegalArgumentException` - Matrix must be square

    - #### solve

          public Matrix solve(Matrix B)

      Solve A*X = B
      Parameters:
        `B` - A Matrix with as many rows as A and any number of columns.
      Returns:
        X so that L*U*X = B(piv,:)
      Throws:
        `IllegalArgumentException` - Matrix row dimensions must agree.
        `RuntimeException` - Matrix is singular.

    - #### Solve

          public double[] Solve(double[] value)

    - #### inverse

          public double[][] inverse()

      Solves a set of equation systems of type A * X = B.
      Returns:
        Matrix X so that L * U * X = B.

Copyright © 2014. All Rights Reserved.